// -*- mode: c++; mode: fold -*-
// Description								/*{{{*/
// $Id$
/* ######################################################################

   pkgRPMCfgBackup - TODO: Summary
 
   TODO: Description

   AUTHOR: David Salvador Pinheiro <david.pinheiro@caixamagica.pt>

   ##################################################################### */
									/*}}}*/
// Include Files							/*{{{*/
#ifdef __GNUG__
#pragma implementation "apt-pkg/rpmcfgbackup.h"
#endif

#include <apt-pkg/rpmcfgbackup.h>
#include <apt-pkg/fileutl.h>

#include <apt-pkg/tar.h>
#include <apt-pkg/configuration.h>
#include <rpm/rpmdb.h>
#include <rpm/rpmlib.h>
#include <rpm/rpmcli.h>

#include <fcntl.h>
#include <unistd.h>
#include <sstream>
#include <iostream>
#include "config.h"
#include "raptheader.h"
									/*}}}*/

pkgRPMCfgBackup::pkgRPMCfgBackup(const char *DBRootDir)
{
}

pkgRPMCfgBackup::~pkgRPMCfgBackup()
{
}

/*
string pkgRPMCfgBackup::FormatFN(const char *pkgName,int TID, const char *pkgVersion, const char *pkgRelease)
{   
   ostringstream FN;
   FN << pkgName <<"-cfg" << TID << "-"<< pkgVersion << "-" << pkgRelease <<".tar.bz2";
   return FN.str();
}
bool pkgRPMCfgBackup::Create(const char *pkgName,int TID)
{
   vector<string> FileList;
   string FileName;   
   string pkgVersion;
   string pkgRelease;
   
   if(GetCfgFileList(pkgName,FileList, pkgVersion, pkgRelease) == false)
      return false;

   if(FileList.empty())
      return false;

   string Dir = _config->FindDir("Dir::Cache::pkgcfg");
   if(FileExists(Dir) == false)
   {
      if( mkdir(Dir.c_str(),0644) == -1)
	 return false;
   }

   FileName = flCombine(Dir,FormatFN(pkgName,TID,pkgVersion.c_str(),pkgRelease.c_str()));
   BckFileList.push_back(FileName);

   return Tar::Create(FileName.c_str(),FileList,Tar::BZ2,NULL,NULL);
}

bool pkgRPMCfgBackup::Restore(const char *pkgName,int TID)
{
   bool Ret;
   string pkgVersion = " ";
   string pkgRelease = " ";
   string CWD = SafeGetCWD();
   string Dir = _config->FindDir("Dir::Cache::pkgcfg");
   string TarFile = flCombine(Dir,FormatFN(pkgName,TID,pkgVersion.c_str(),pkgRelease.c_str()));

   chdir ("/");
   if(FileExists(TarFile) == false)
      return false;

   Ret = Tar::Extract(TarFile.c_str(),Tar::BZ2, NULL, NULL);
   chdir(CWD.c_str());

   return Ret;
}
*/

bool pkgRPMCfgBackup::GetCfgFileList(const char *pkgName,vector<string> &FileList, string &pkgVersion, string &pkgRelease)
{   
   
  stringstream rpmDbDump;
  rpmts ts = rpmtsCreate();
  Header hdr;
  rpmfi fi = NULL;
  int scareMem = 0;
  int i;
   
  rpmtsSetRootDir(ts, "/");
   
  if (rpmtsGetRdb(ts) == NULL) {
    int rc = rpmtsOpenDB(ts, O_RDONLY);
  }

  // Sanitize package name - removing architecture ".x86-64 .."                       
  char *tmpName=(char *)malloc(strlen(pkgName)+1);
  char *ptrTmpName;
  strncpy(tmpName, pkgName,strlen(pkgName));
   
  if ((ptrTmpName=strchr(tmpName,'.')) != NULL) {
    *ptrTmpName=0;
  }

   
  rpmdbMatchIterator Iter = rpmtsInitIterator(ts, RPMTAG_NAME, tmpName, 0);

  while ((hdr = rpmdbNextIterator(Iter)) != NULL)
    {


      rpmtd tagdata = rpmtdNew();

      if (headerGet(hdr, RPMTAG_VERSION, tagdata, HEADERGET_RAW)) {
  	pkgVersion = rpmtdGetString(tagdata);
      }
      if (headerGet(hdr, RPMTAG_RELEASE, tagdata, HEADERGET_RAW)) {
  	pkgRelease = rpmtdGetString(tagdata);
      }
   
      fi = rpmfiNew(ts, hdr, RPMTAG_BASENAMES, scareMem);
      if (rpmfiFC(fi) <= 0) {
  	rpmtdFreeData(tagdata);
  	rpmtdFree(tagdata);

  	break;
      }

      fi = rpmfiInit(fi, 0);
      while ((i = rpmfiNext(fi)) >= 0) {
        const char *fn = rpmfiFN(fi);
        rpmfileAttrs fflags = rpmfiFFlags(fi);
  	if ((fflags & RPMFILE_CONFIG)) {
  	  FileList.push_back(fn);
   }

	
      }
      rpmtdFreeData(tagdata);
      rpmtdFree(tagdata);

    }

  Iter = rpmdbFreeIterator(Iter);
  fi = rpmfiFree(fi);  

  int rc=rpmtsCloseDB(ts);

   return true;


}

/*
bool pkgRPMCfgBackup::DeleteBckUPFiles()
{
   bool Ret = true;

   for(list<string>::iterator I = BckFileList.begin(); I != BckFileList.end(); I++)
   {
      if(unlink((*I).c_str()))
	 Ret = false;
   }

   return Ret;
}
*/

// vim:sts=3:sw=3
